open Softcore

(* Strategies : see developper doc *)

(* 'a will actually always be Block.t *)
type 'a t = ModelFound of 'a | NoModelFound
(*
 *let (&) s1 s2 =
 *  match s1 with
 *  |ModelFound _ -> ModelFound
 *  |NoModelFound -> s2
 *)

let satisfiable = function
  |ModelFound _ -> true
  |NoModelFound -> false

let unsatisfiable x = not (satisfiable x)

let model = function
  |ModelFound a -> Some a
  |NoModelFound -> None
